--Code by Boolsheet to help with... bullshit canvas blendmode issues.

-- Mulplies r, g, and b with a. This rules out transparent colors which is important in premultiplied mode.
function multiplyChannels(r, g, b, a)
   return (r * a)/255, (g * a)/255, (b * a)/255, a
end

-- Function for ImageData:mapPixel. It will give us the image we need for premultiplied.
function premultiplyMapPixel(x, y, r, g, b, a)
   return multiplyChannels(r, g, b, a)
end

function premultiply(tex)
    local textmp = tex
    for i, v in pairs(tex) do
        textmp[i]:mapPixel(premultiplyMapPixel)
        tex[i] = love.graphics.newImage(textmp[i])
    end
end